'##################################################################################################
SuperStrict

'##################################################################################################
'Framework & Imports
Framework BRL.Socket
Import BRL.SocketStream
Import BRL.LinkedList
Import BRL.StandardIO
Import BRL.HTTPStream
Import BRL.Retro
Import BRL.System

'##################################################################################################
Include "source\TWebParser.bmx"
Include "source\TElement.bmx"
Include "source\TCommand.bmx"
Include "source\THTMLGenerator.bmx"

'##################################################################################################
Print "Title: Leadwerks Docs Builder"
Print "Description: Downloads Leadwerks commands and adds them to the MaxIDE syntax highlighting and generates a HTML help page."
Print ""

'##################################################################################################
Global CommandsTxtPath:String
Global CommandsHtmlPath:String
Global LogoPngPath:String
Global BlitzMaxPath:String

Print "#######################################"
Print "Please choose your BlitzMax path!"

Repeat
	BlitzMaxPath = RequestDir( "Select your BlitzMax directory" )
	If( BlitzMaxPath <> "" )
		If( Right( BlitzMaxPath, 1 ) <> "\" ) Then BlitzMaxPath = BlitzMaxPath + "\"
		If( FileType( BlitzMaxPath + "maxide.exe" ) )	
			Print "Path OK!"
			CommandsTxtPath = BlitzMaxPath + "docs\html\Modules\commands.txt"
			CommandsHtmlPath = BlitzMaxPath + "mod\leadwerks.mod\engine.mod\doc\commands.html"
			LogoPngPath = BlitzMaxPath + "mod\leadwerks.mod\engine.mod\doc\logo.png"
			Exit
		Else
			Print "Invalid Path!"
		EndIf
	Else
		Print "Exiting in 2 seconds.."
		Delay 2000
		End
	EndIf
Forever
Print ""

'##################################################################################################
'Categories here:
'http://www.leadwerks.com/wiki/index.php?title=Special:Categories

Local PageList:TList = CreateList()

ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Application" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Bodies" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Buffers" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Camera" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Collision" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Controllers" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Coronas" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Drawing" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Emitter" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Entities" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Entity_Hierarchy" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Entity_Movement" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Entity_State" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Entity_Transformation" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:File_System" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Graphics" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Groups" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Input" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Joints" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Lights" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Listeners" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Materials" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:MeshLayers" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Meshes" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Models" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Pivots" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Sound" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Surfaces" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Shaders" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Terrain" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Timing" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Vehicles" ) )
ListAddLast( PageList, String( "http::www.leadwerks.com/wiki/index.php?title=Category:Worlds" ) )

For Local A:String = EachIn PageList
	Print "#######################################"
	Print "-Downloading commands-"
	Print "'" + A + "'"
	Print ""
	Local Parser:TWebParser = TWebParser.Create()
	Parser.LoadFromURL( A )
	Local TR:String = Parser.GetElementContent( "tr", BmxToHTML( "valign='top'" ) )
	
	If( TR <> "" )
	
		Parser.Clear()
		Parser.LoadFromString( TR )
		
		For Local A:TElement = EachIn Parser.GetElements( "a" )
			TCommand.Create( "www.leadwerks.com" + A.GetParameter( "href" ) )
		Next
	Else
		
		Local Div:String = Parser.GetElementContent( "div", BmxToHTML( "id='mw-pages'" ) )
		
		Parser.Clear()
		Parser.LoadFromString( Div )
		
		For Local A:TElement = EachIn Parser.GetElements( "a" )
			TCommand.Create( "www.leadwerks.com" + A.GetParameter( "href" ) )
		Next
		
	EndIf
	Print ""
Next

Print "#######################################"
Print "Sorting commands.."

SortList( TCommand.List, True, CompareFunc )

Function CompareFunc:Int( o1:Object, o2:Object )
	If TCommand( o1 ).Name > TCommand( o2 ).Name Then Return 1
	Return 0
End Function

Print ""
Print "#######################################"
Print "Generating HTML.."

CreateDir( ExtractDir( CommandsHtmlPath ) )
THTMLGenerator.Generate( CommandsHtmlPath )
CopyFile( "html\logo.png", LogoPngPath )

Local File:TStream = OpenFile( CommandsTxtPath )
	SeekStream( File, StreamSize( File ) )
	For Local A:TCommand = EachIn TCommand.List
		WriteLine( File, A.Command + "|" + "/mod/leadwerks.mod/engine.mod/doc/commands.html#" + A.Name )
	Next
CloseFile( File )

Print ""
Print "#######################################"
Print "PROCESS COMPLETE!"
Print "Exiting in 5 seconds.."
Delay 5000
End

'##################################################################################################

Function BmxToHTML:String( Str:String )
	Local NewStr:String = Replace( Str, "'", Chr(34) )
	Return NewStr
End Function
'##################################################################################################