Type TCommand
	
	Global List:TList = CreateList()
	
	Field Name:String
	Field Command:String, CommandInfo:String
	Field Description:String
	Field Example:String
	Field URL:String
	
	Function Create:TCommand( URL:String )
		Local A:TCommand = New TCommand
		A.URL = URL
		A.Parse()
		Return( A )
	End Function
	
	Method Parse()
		Local Parser:TWebParser = TWebParser.Create()
		Local Data:String = Parser.ReturnHTML( "http::" + URL )
		
		'##### NAME #####
		GetName( Data )
		
		'##### COMMAND #####
		GetCommand( Data )
		
		'##### EXAMPLE #####
		GetExample( Data )
		
		'##### DESCRIPTION #####
		GetDescription( Data )
		
		'##### COMMAND INFO #####
		GetCommandInfo( Data )
		
		'Exceptions
		Local Added:Int = False
		If( Lower( Left( Name, 8 ) ) <> "template" )
			If( Right( Name, 3 ) <> "..." )
				ListAddLast( TCommand.List, Self )
				Added = True
			EndIf
		EndIf
		
		If( Self.Command = "" )
			Self.Command = Self.Name
		EndIf
		
		If( Self.Description = "" )
			Self.Description = Self.CommandInfo
		EndIf
		
		If( Added = True )
			Print "'" + Name + "' done."
		EndIf
		
	End Method
	
	Method GetCommandInfo( Str:String )
		Local Parser:TWebParser = TWebParser.Create()
		Parser.LoadFromString( Str )
		
		Local Table:String = Parser.GetElementContent( "table", BmxToHTML( "cellpadding='2' style='font-size:95%;background-color:AliceBlue;'" ) )
		Parser.Clear()
		Parser.LoadFromString( Table )
		Self.CommandInfo= Parser.GetElementContent( "td" )
	End Method
	
	Method GetDescription( Str:String )
		Local Parser:TWebParser = TWebParser.Create()
		Parser.LoadFromString( Str )
		
		For Local A:TElement = EachIn Parser.GetElements( "span", BmxToHTML( "class='mw-headline'" ) )
			If( Lower( A.GetContent( Str ) ) = " description " )
				Local NextElem:TElement = Parser.GetNextElement( A )
				If( NextElem.Name = "p" )
					Self.Description = NextElem.GetContent( Str )
				EndIf
			EndIf
		Next
	End Method
	
	Method GetExample( Str:String )
		Local Parser:TWebParser = TWebParser.Create()
		Parser.LoadFromString( Str )
		Self.Example:String = Parser.GetElementContent( "pre", BmxToHTML( "class='de1'" ) )
	End Method
	
	Method GetName( Str:String )
		Local Parser:TWebParser = TWebParser.Create()
		Parser.LoadFromString( Str )
		Self.Name = Parser.GetElementContent( "h1", BmxToHTML( "class='firstHeading'" ) )
	End Method
	
	Method GetCommand( Str:String )
		Local Parser:TWebParser = TWebParser.Create()
		Parser.LoadFromString( Str )
		
		Local Count:Int = 0
		For Local A:TElement = EachIn Parser.GetElements( "font", BmxToHTML( "color='#6E6E6E'" ) )
			If( A.GetContent( Str ) = "BMX:" )
				Exit
			EndIf
			Count = Count + 1
		Next
		
		Self.Command = Parser.GetElementContent( "td", BmxToHTML( "align='left' valign='top'" ), Count )
	End Method
	
End Type